
   * [v0.3.0](#v030)
      * [Downloads for v0.3.0](#downloads-for-v030)
         * [KubeEdge Binaries](#kubeedge-binaries)
         * [Installer Binaries](#installer-binaries)
   * [KubeEdge v0.3 Release Notes](#kubeedge-v03-release-notes)
      * [0.3 What's New](#03-whats-new)
      * [Known Issues](#known-issues)
      * [Other Notable Changes](#other-notable-changes)
   * [v0.3.0-beta.0](#v030-beta0)
      * [Downloads for v0.3.0-beta.0](#downloads-for-v030-beta0)
         * [KubeEdge Binaries](#kubeedge-binaries-1)
         * [Installer Binaries](#installer-binaries-1)
      * [Changelog since v0.2.1](#changelog-since-v021)
         * [Features Added](#features-added)
         * [Known Issues](#known-issues-1)
         * [Other notable changes](#other-notable-changes-1)
   * [v0.2.1](#v021)
      * [Downloads for v0.2.1](#downloads-for-v021)
      * [Changelog since v0.2.0](#changelog-since-v020)
         * [Bug fixes](#bug-fixes)
         * [Known issues](#known-issues-2)
   * [v0.2](#v02)
      * [Downloads for v0.2](#downloads-for-v02)
   * [KubeEdge v0.2 Release Notes](#kubeedge-v02-release-notes)
      * [Features added](#features-added-1)
      * [Known issues](#known-issues-3)
      * [Features Work In Progress (Future release)](#features-work-in-progress-future-release)
   * [v0.1](#v01)
      * [Downloads for v0.1](#downloads-for-v01)
   * [KubeEdge v0.1 Release Notes](#kubeedge-v01-release-notes)
      * [Features supported](#features-supported)
      * [Known issues](#known-issues-4)
      * [Features Work In Progress (Future release)](#features-work-in-progress-future-release-1)

# v0.3.0

## Downloads for v0.3.0

### KubeEdge Binaries
| filename | Size | sha512 hash |
| -------- | ---- | ----------- |
| [kubeedge-v0.3.0-linux-amd64.tar.gz](https://github.com/kubeedge/kubeedge/releases/download/v0.3.0/kubeedge-v0.3.0-linux-amd64.tar.gz) | 37.9 MB | `25761cbb6aeab1b778990acb6cd82dda0febcb8354b75636266dc39ecd9377da0e78f477220e3f2d578f51d63de678665fa1aff62c68523ae74c2496f52c17e2` |
| [kubeedge-v0.3.0-linux-arm.tar.gz](https://github.com/kubeedge/kubeedge/releases/download/v0.3.0/kubeedge-v0.3.0-linux-arm.tar.gz) | 34.8 MB | `fc17e3f2b01d9c54e00f5cbfb32c48d53b7ec0ef8f4a0ab8484fd164587d7d083d463ef0e4be06ab4f6e9205dc95df277c06a9e6b082450f2ffd1cb63c176d56` |

### Installer Binaries
| filename | Size | sha512 hash |
| -------- | ---- | ----------- |
| [keadm-v0.3.0-linux-amd64.tar.gz](https://github.com/kubeedge/kubeedge/releases/download/v0.3.0/keadm-v0.3.0-linux-amd64.tar.gz) | 2.23 MB | `bce839fef66e0e370876dbbdc671129f3e209d03e7530992ea84bb0bc804fd0a88182db06852266a3cde80e52c0b8ae7bc8f58ff2022acb88f67dd8d6f5b11d3` |


# KubeEdge v0.3 Release Notes

## 0.3 What's New

**Device Management using CRD**

This feature mainly provides APIs for managing devices from cloud and synchronize the device updates between cloud and edge.
DeviceController is the module in cloud which is responsible for watching on devices and devicemodels and syncing the data to edge. DeviceController is also responsible for receiving the device-twin updates sent from edge and making the changes in cloud(apiserver). DeviceController also creates a configmap for each node and adds the deviceInstances, protocols, properties and propertyVisitors in it. This configmap can be consumed by any application like mapper and used to configure/control devices.

**Bluetooth Mapper**

Bluetooth Mapper is an application that is used to connect and control devices that use bluetooth as a communication protocol. It consumes the configmap generated by device-controller and reuires a configuration file for information not present in configmap. Configurations can be changed at runtime by providing the input through the MQTT broker. It can run schedule based actions and converts data received from devices into edge_core expected format.

**Performance Test Framework**

Benchmarking framework to measure the performance against the following Service Level Objectives:
    - Latency: time cost from the moment when the server gets the request to last byte of response sent to the users.
    - Throughput: measure how many requests can be served within given time.
    - Scalability: potential scaling capacity (including number of nodes, pods, devices etc. at the edge) under different load conditions.
    - CPU Usage: measure the cpu usage of KubeEdge under different load conditions.
    - Memory Usage: measure the memory usage of KubeEdge under different load conditions.

**KubeEdge Installer**
Support for basic commands to bootstrap and teardown both KubeEdge cloud and edge components.
Supported Commands :
    - `kubeedge init` : bootstrap cloud prerequisites and cloud components if not already present.
    - `kubeedge join` : add edge node in cloud api-server, bootstrap edge prerequisites and edge components if not already present.
    - `kubeedge reset` : tears down the installed components/prerequisites. The reset action has to be done on the cloud and edge nodes separately to ensure proper cleanup.

## Known Issues


- API Validation for device CRD is missing.

- UT/e2e coverage should be improved for cloud part.

- Partitioning of device configmap.

- Running edged and k8s master on same VM kills k8s master pods.

## Other Notable Changes

- Handled the case of invalid action in scheduler module ([#563](https://github.com/kubeedge/kubeedge/pull/563), [@sujithsimon22](https://github.com/sujithsimon22))

- Added nil pointer handling in watcher,go ([#561](https://github.com/kubeedge/kubeedge/pull/561), [@sujithsimon22](https://github.com/sujithsimon22))

- Corrected the topic name being used in bluetooth_mapper ([#559](https://github.com/kubeedge/kubeedge/pull/559), [@sujithsimon22](https://github.com/sujithsimon22))

- Mismatch in access mode names ([#558](https://github.com/kubeedge/kubeedge/pull/558), [@sujithsimon22](https://github.com/sujithsimon22))

- Fix edge_core crashs when SecurityContext.Privileged pointer ([#555](https://github.com/kubeedge/kubeedge/pull/555), [@shouhong](https://github.com/shouhong))

- Supports automatic deletion of edge containers if their pods ([#537](https://github.com/kubeedge/kubeedge/pull/537), [@shouhong](https://github.com/shouhong))

- fix nil pointer panic possibility in deviceController ([#501](https://github.com/kubeedge/kubeedge/pull/501), [@sids-b](https://github.com/sids-b))

- Make file changes to fix #issue 496 ([#497](https://github.com/kubeedge/kubeedge/pull/497), [@srivatsav123](https://github.com/srivatsav123))

- Fixed restart issue of mapper ([#492](https://github.com/kubeedge/kubeedge/pull/492), [@sujithsimon22](https://github.com/sujithsimon22))

- fix EdgeController config keys ([#490](https://github.com/kubeedge/kubeedge/pull/490), [@sids-b](https://github.com/sids-b))

- Added README.MD for KubeEdge installer #issue-477. ([#489](https://github.com/kubeedge/kubeedge/pull/489), [@srivatsav123](https://github.com/srivatsav123))

- fix the broken link ([#481](https://github.com/kubeedge/kubeedge/pull/481), [@lou-lan](https://github.com/lou-lan))

- Device CRD: remove configmap when no device is bound with ([#479](https://github.com/kubeedge/kubeedge/pull/479), [@chendave](https://github.com/chendave))

- Changed exit status from 0 to 1 when bluetooth mapper exits ([#475](https://github.com/kubeedge/kubeedge/pull/475), [@sujithsimon22](https://github.com/sujithsimon22))

- Added Device CRD sample for CC2650 Bluetooth device ([#472](https://github.com/kubeedge/kubeedge/pull/472), [@sujithsimon22](https://github.com/sujithsimon22))

- update setup steps in docs.kubeedge.io ([#470](https://github.com/kubeedge/kubeedge/pull/470), [@edisonxiang](https://github.com/edisonxiang))

- Distinguish debugging information between controller and ([#462](https://github.com/kubeedge/kubeedge/pull/462), [@kadisi](https://github.com/kadisi))

- delete useless field messageLayer ([#459](https://github.com/kubeedge/kubeedge/pull/459), [@kadisi](https://github.com/kadisi))

- Added lableselectors logic to deploy kubeedge edgenode pod to ([#453](https://github.com/kubeedge/kubeedge/pull/453), [@pavan187](https://github.com/pavan187))

- Fix #463: Update kubeedge architecture ([#504](https://github.com/kubeedge/kubeedge/pull/504), [@rohitsardesai83](https://github.com/rohitsardesai83))

- docs: [ Fix #436 ] : Apply device CRDs before running cloud. ([#450](https://github.com/kubeedge/kubeedge/pull/450), [@rohitsardesai83](https://github.com/rohitsardesai83))


# v0.3.0-beta.0

[Documentation](https://docs.kubeedge.io)

## Downloads for v0.3.0-beta.0

### KubeEdge Binaries
| filename | Size | sha512 hash |
| -------- | ---- | ----------- |
| [kubeedge-v0.3.0-beta.0-linux-amd64.tar.gz](https://github.com/kubeedge/kubeedge/releases/download/v0.3.0-beta.0/kubeedge-v0.3.0-beta.0-linux-amd64.tar.gz) | 34.3 MB | `7ec485e03611261b544196c83caa5136d6a364fbf01b28009215566ef0b31d60de02e439cd55e1c9a01db8e6a0c06717b17e6ec8f15704031eab890c0dd75e1a` |
| [kubeedge-v0.3.0-beta.0-linux-arm.tar.gz](https://github.com/kubeedge/kubeedge/releases/download/v0.3.0-beta.0/kubeedge-v0.3.0-beta.0-linux-arm.tar.gz) | 31.4 MB | `d70a016673c4ee6f1cf8dc76e0af8c54266a5e355d560093846f56ead684035af83241a1035db59486a716b15ebc40ae0188d42608cbf95a86de8b838a8e1195` |


### Installer Binaries
| filename | Size | sha512 hash |
| -------- | ---- | ----------- |
| [keadm-v0.3.0-beta.0-linux-amd64.tar.gz](https://github.com/kubeedge/kubeedge/releases/download/v0.3.0-beta.0/keadm-v0.3.0-beta.0-linux-amd64.tar.gz) | 2.05 MB | `5775c5c1b25a9148fd592cf61e0cd671ca8fb345c63c897709bda2c479bb3a315c9f979e934fbd5a79dfcb633f793ffe948979773e65f95c65791b4ac08c3d0f` |

## Changelog since v0.2.1

### Features Added


- Device Management using CRDs : This feature mainly provides APIs for managing devices from cloud and synchronize the device updates between cloud and edge. DeviceController is the module in cloud which is responsible for watching on devices and devicemodels and syncing the data to edge. DeviceController is also responsible for receiving the device-twin updates sent from edge and making the changes in cloud(apiserver). DeviceController also creates a configmap for each node and adds the deviceInstances, protocols, properties and propertyVisitors in it. This configmap can be consumed by any application like mapper and used to configure/control devices.


- Bluetooth Mapper : Bluetooth Mapper is an application that is used to connect and control devices that use bluetooth as a communication protocol. It consumes the configmap generated by device-controller and reuires a configuration file for information not present in configmap. Configurations can be changed at runtime by providing the input through the MQTT broker. It can run schedule based actions and converts data received from devices into edge_core expected format.


- Performance Test Framework : Benchmarking framework to measure the performance against the following Service Level Objectives:
    - Latency: time cost from the moment when the server gets the request to last byte of response sent to the users.
    - Throughput: measure how many requests can be served within given time.
    - Scalability: potential scaling capacity (including number of nodes, pods, devices etc. at the edge) under different load conditions.
    - CPU Usage: measure the cpu usage of KubeEdge under different load conditions.
    - Memory Usage: measure the memory usage of KubeEdge under different load conditions.


- KubeEdge Installer : Support for basic commands to bootstrap and teardown both KubeEdge cloud and edge components.
Supported Commands :
    - `kubeedge init` : bootstrap cloud prerequisites and cloud components if not already present.
    - `kubeedge join` : add edge node in cloud api-server, bootstrap edge prerequisites and edge components if not already present.
    - `kubeedge reset` : tears down the installed components/prerequisites. The reset action has to be done on the cloud and edge nodes separately to ensure proper cleanup.

### Known Issues


- API Validation for device CRD is missing.

- UT/e2e coverage should be improved for cloud part.

- Partitioning of device configmap.

- Running edged and k8s master on same VM kills k8s master pods.

### Other notable changes


- UT for devicetwin/dtmanager/twin.go. ([#300](https://github.com/kubeedge/kubeedge/pull/300), [@omung-g](https://github.com/omung-g))

- Add Kubernetes deployment for Edge. ([#367](https://github.com/kubeedge/kubeedge/pull/367), [@edisonxiang](https://github.com/edisonxiang))

- Adding UT for cloudhub/common/model/types.go. ([#395](https://github.com/kubeedge/kubeedge/pull/395), [@omung-g](https://github.com/omung-g))

- output time duration per test case. ([#397](https://github.com/kubeedge/kubeedge/pull/397), [@edisonxiang](https://github.com/edisonxiang))

- Adding unit tests for device.go. ([#376](https://github.com/kubeedge/kubeedge/pull/376), [@lidiyag](https://github.com/lidiyag))

- Fix the nil pointer exception for missing config string ([#432](https://github.com/kubeedge/kubeedge/pull/432), [@trilokgm](https://github.com/trilokgm))

# v0.2.1
## Downloads for v0.2.1
| filename | Size |
| -------- | ---- |
| [kubeedge-v0.2.1-linux-amd64.tar.gz](https://github.com/kubeedge/kubeedge/releases/download/v0.2.1/kubeedge-v0.2.1-linux-amd64.tar.gz) |  34.2 MB |
| [kubeedge-v0.2.1-linux-arm.tar.gz](https://github.com/kubeedge/kubeedge/releases/download/v0.2.1/kubeedge-v0.2.1-linux-arm.tar.gz) |  31.4 MB |



## Changelog since v0.2.0

### Bug fixes

https://github.com/kubeedge/kubeedge/pull/354
https://github.com/kubeedge/kubeedge/pull/328

### Known issues
1. service bus at edge cannot be used until router support is added in the cloud.

# v0.2

## Downloads for v0.2
| filename | Size |
| -------- | ---- |
| [kubeedge-v0.2-linux-amd64.tar.gz](https://github.com/kubeedge/kubeedge/releases/download/v0.2/kubeedge-v0.2-linux-amd64.tar.gz) |  25.7 MB |
| [kubeedge-v0.2-linux-arm.tar.gz](https://github.com/kubeedge/kubeedge/releases/download/v0.2/kubeedge-v0.2-linux-arm.tar.gz) |  31.4 MB |

# KubeEdge v0.2 Release Notes
This is the second release of KubeEdge. **Cloud is there finally!**

## Features added
1. Edge-controller which connects to Kubernetes api-server and sync node/pod status between edge and kubernetes api-server.
2.  Cloudhub which is a websocket server in cloud part of kubeedge.
3. Internal MQTT mode in which MQTT broker is started with edge_core and removes dependency on external MQTT broker.
4. Integration test framework for edge. Improved edge_core unit-test coverage.

## Known issues
1. We do not have any e2e tests yet.
2. Unit tests coverage should be improved for cloud part.

## Features Work In Progress (Future release)
1. Describe device API via CRD.
2. Edge to Edge Communication.
3. Different Protocol support for KubeEdge like BLE, Zigbee,etc.

# v0.1
## Downloads for v0.1
| filename | Size |
| -------- | ---- |
| [kubeedge-v0.1-linux-amd64.tar.gz](https://github.com/kubeedge/kubeedge/releases/download/v0.1/kubeedge-v0.1-linux-amd64.tar.gz) |  21.9 MB |

# KubeEdge v0.1 Release Notes
This is kubeedge's first release.

## Features supported
1. A lightweight application engine running on edge node for managing user's application and monitoring node health.
2. Supports Kubernetes API primitives, e.g. Node, Pod, Configmap, Secrets etc.
3. Device twin and MQTT protocol for IoT devices talking to Edge node
4. Local self-governance via HTTP restful interfaces.
5. Integrated with Huawei Cloud IEF service for node, device and application status updates.
6. Edge node autonomy when its getting offline and recover post reconnection to Cloud.

## Known issues
1. We do not have any e2e tests yet.
2. Unit tests coverage should be improved.

## Features Work In Progress (Future release)
1. Develop and open-source the cloud part components.
2. Describe device API via CRD.
